#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <thread.h>
#include <auth.h>
#include <9p.h>
#include <json.h>
#include "jsonfs.h"
#include "axosoft.h"

static const char *UriList = "columns=id";

static int
add(Node *n, Sess *s)
{
	Axo *axo;
	Jvalue *v;

	axo = n->aux;
	if((v = exch(s, nil, "api/v5/attachments/%d", axo->id)) == nil){
		warn("cannot scan for attachment, %r\n");
		return -1;
	}

	json_free(v);
	return 0;
}

/* add attachaments */
int
attachscan(Node *n, Sess *s)
{
	int i;
	char *p;
	Node *ch;
	Jvalue *v;

	if((v = exch(s, nil, "api/v5/attachments?%s", UriList)) == nil){
		warn("cannot scan for tasks, %r\n");
		return -1;
	}

	for(i = 0; (p = json_strval(v, "data[%d]/id", i)) != nil; i++){
		ch = newdir(n, nil, nil, nil, p);
		ch->aux = newaxo(p);
		ch->scan = add;
	}

	json_free(v);
	return 0;
}

