typedef struct Sess Sess;

typedef int (*Scanfunc)(Node *n, Sess *s);
typedef int (*Walkfunc)(Node *n, Sess *s, char *name);
typedef int (*Flushfunc)(Node *n, Sess *s, void *buf, int len);

struct Sess  {
	char *url;			/* host URL */
	char version[128];	/* server version */
	char *webfs;		/* where to find webfs */
	int conid;			/* /net connection ID */
	int fd;				/* webfs session */
	char *headers;		/* extra HTTP headers to send */
	char *userid;		/* authenticated user ID */
};

/* auth.c */
int auth(Sess *s, char *pkgname);

/* cache.c */
char *id2login(Sess *s, char *id);
void cacheuser(char *id, char *name);

/* defects.c */
int adddefect(Node *n, Sess *s);
int defectscan(Node *n, Sess *s);
int defectwalk(Node *n, Sess *s, char *name);

/* features.c */
int addfeature(Node *n, Sess *s);
int featurescan(Node *n, Sess *s);
int featurewalk(Node *n, Sess *s, char *name);

/* incidents.c */
int addincident(Node *n, Sess *s);
int incidentscan(Node *n, Sess *s);
int incidentwalk(Node *n, Sess *s, char *name);

/* items.c */
int additem(Node *n, Sess *s, char *name);
int additems(Node *n, Sess *s, char *item);

/* projects.c */
int projectscan(Node *n, Sess *s);

/* tasks.c */
int addtask(Node *n, Sess *s);
int taskscan(Node *n, Sess *s);
int taskwalk(Node *n, Sess *s, char *name);

/* users.c */
int alluserscan(Node *n, Sess *s);
int oneuserscan(Node *n, Sess *s);
int localscan(Node *n, Sess *s);

/* workflow.c */
int workflowscan(Node *n, Sess *s);

/* teams.c */
int teamscan(Node *n, Sess *s);

extern char *Debug;
extern char *UriList;
extern char *UriSelect;


