#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <thread.h>
#include <auth.h>
#include <9p.h>
#include <bio.h>
#include <json.h>
#include "jsonfs.h"
#include "axosoft.h"

/* add all defects returned */
int
defectscan(Node *n, Sess *s)
{
	return additems(n, s, "defects");
}

int
adddefect(Node *n, Sess *s)
{
	return additem(n, s, "defects");
}

/* validate and create a single defect dir */
int
defectwalk(Node *n, Sess *s, char *name)
{
	Node *ch;
	Jvalue *v;

	if((v = exch(s, nil, "api/v5/defects/%s?%s", name, UriList)) == nil)
		return -1;

	ch = newdir(n, nil, nil, nil, name);
	ch->aux = estrdup9p(name);
	ch->scan = adddefect;
	json_free(v);
	return 0;
}
