#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <thread.h>
#include <auth.h>
#include <9p.h>
#include <bio.h>
#include <json.h>
#include "jsonfs.h"
#include "axosoft.h"

/* add all features returned */
int
featurescan(Node *n, Sess *s)
{
	return additems(n, s, "features");
}

int
addfeature(Node *n, Sess *s)
{
	return additem(n, s, "features");
}

/* validate and create a single feature dir */
int
featurewalk(Node *n, Sess *s, char *name)
{
	Node *ch;
	Jvalue *v;

	if((v = exch(s, nil, "api/v5/features/%s?%s", name, UriList)) == nil)
		return -1;

	ch = newdir(n, nil, nil, nil, name);
	ch->aux = estrdup9p(name);
	ch->scan = addfeature;
	json_free(v);
	return 0;
}

