enum {
	Permenant = -1,		/* last access time of permenant files/dirs */
};


typedef struct Sess Sess;
typedef struct Node Node;

#pragma incomplete Sess

typedef int (*Scanfunc)(Node *n, Sess *s);
typedef int (*Walkfunc)(Node *n, Sess *s, char *name);
typedef int (*Flushfunc)(Node *n, Sess *s, void *buf, int len);

struct Node {
	Node *parent;
	Node *child;
	Node *next;
	Dir dir;

	char *buf;			/* read content */
	char *url;			/* url to load content from */
	Scanfunc scan;		/* called on open of a dir, reload dir contents */
	Walkfunc walk;		/* called on walk, check dir exists */
	Flushfunc flush;	/* called on destroyfid, flush written file */
	int mkdir;			/* create: allow dirs creation, not files */
	long last;			/* time(2) data last refreshed */
	void *aux;			/* understood by lower layers */
};


/* fs.c */
Node *newdir(Node *n, char *uid, char *gid, char *muid, char *name);
Node *newfile(Node *n, char *name, char *uid, char *gid, char *muid, long mtime, long atime, char *str);
void writable(Node *n);
Node *newurl(Node *n, char *name, char *uid, char *gid, char *muid, long mtime, vlong length, char *url);
void startfs(Sess *s, Node *skyhook, int tout, char *name, char *svs, char *mtpt);

/* httperrstr.c */
void httperrstr(int n);

/* misc.c */
void warn(char *fmt, ...);
char *strlwr(char *str);
char *strupr(char *str);
int httphdr(Sess *s, char *field, char *buf, int len);
Jvalue *exch(Sess *s, char *post, char *fmt, ...);
char *fetch(Sess *s, vlong *len, char *fmt, ...);
int dialweb(Sess *s, char *relm);
long iso2sec(char *s);
char *basename(char *s);
char *getkey(char *attr, char *fmt, ...);

