#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <thread.h>
#include <auth.h>
#include <9p.h>
#include <bio.h>
#include <json.h>
#include "jsonfs.h"
#include "axosoft.h"


/* add a child project directory and children recursively */
static void
addproj(Node *n, Sess *s, Jvalue *v, char *base)
{
	int i;
	Node *ch;
	char *p, *prefix;

	for(i = 0; (p = json_strval(v, '.', "%s[%d].name", base, i)) != nil; i++){
		ch = newdir(n, nil, nil, nil, p);
		ch->aux = estrdup9p(p);

		if(json_strval(v, '.', "%s[%d].children[0].name", base, i) != nil){
			prefix = smprint("%s[%d]/children", base, i);
			addproj(ch, s, v, prefix);
			free(prefix);
		}
	}
}

/* add project directory hierarchy */
int
projectscan(Node *n, Sess *s)
{
	Jvalue *v;

	if((v = exch(s, nil, "api/v5/projects?extended=all")) == nil){
		warn("cannot scan for projects, %r\n");
		return -1;
	}

	addproj(n, s, v, "data");
	json_free(v);
	return 0;
}


