#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <thread.h>
#include <auth.h>
#include <9p.h>
#include <bio.h>
#include <json.h>
#include "jsonfs.h"
#include "axosoft.h"

/* add all tasks returned */
int
taskscan(Node *n, Sess *s)
{
	return additems(n, s, "tasks");
}

int
addtask(Node *n, Sess *s)
{
	return additem(n, s, "tasks");
}

/* validate and create a single task dir */
int
taskwalk(Node *n, Sess *s, char *name)
{
	Node *ch;
	Jvalue *v;

	if((v = exch(s, nil, "api/v5/tasks/%s?%s", name, UriList)) == nil)
		return -1;

	ch = newdir(n, nil, nil, nil, name);
	ch->aux = estrdup9p(name);
	ch->scan = addtask;
	json_free(v);
	return 0;
}

