#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <thread.h>
#include <auth.h>
#include <9p.h>
#include <bio.h>
#include <json.h>
#include "jsonfs.h"
#include "axosoft.h"


/* add a child team directory and children recursively */
static char *
members(Sess *s, char *id)
{
	int i;
	Fmt f;
	Jvalue *v;
	char *p;

	if((v = exch(s, nil, "api/v5/teams/%s", id)) == nil){
		warn("cannot scan for teams, %r\n");
		return nil;
	}
	fmtstrinit(&f);
	for(i = 0; (p = json_strval(v, '.', "data.users[%d].name", i)) != nil; i++)
		fmtprint(&f, "%s\n", p);
	json_free(v);
	return fmtstrflush(&f);
}

/* add team directory hierarchy */
int
teamscan(Node *n, Sess *s)
{
	int i;
	Jvalue *v;
	char *p, *name, *id;

	if((v = exch(s, nil, "api/v5/teams")) == nil){
		warn("cannot scan for teams, %r\n");
		return -1;
	}

	for(i = 0; (name = json_strval(v, '.', "data[%d].name", i)) != nil && *name; i++){
		if((id = json_strval(v, '.', "data[%d].id", i)) != nil && *id){
			p = members(s, id);
			newfile(n, name, name, name, name, 0, 0, p);
			free(p);
		}
	}
	json_free(v);
	return 0;
}


