#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <thread.h>
#include <auth.h>
#include <9p.h>
#include <bio.h>
#include <json.h>
#include "jsonfs.h"
#include "axosoft.h"

int
workflowscan(Node *n, Sess *s)
{
	Fmt f;
	int i, j;
	Jvalue *v;
	char *p, *name;

	if((v = exch(s, nil, "api/v5/workflows")) == nil){
		warn("cannot get workflows, %r\n");
		return -1;
	}

	for(i = 0; (name = json_strval(v, '.', "data[%d].name", i)) != nil; i++){

		if((p = json_strval(v, '.', "data[%d].is_active", i)) == nil)
			continue;
		if(strcmp(p, "true") != 0)
			continue;

		fmtstrinit(&f);
		for(j = 0; (p = json_strval(v, '.', "data[%d].workflow_steps[%d].id", i, j)) != nil; j++){
			fmtprint(&f, "%-4s", p);
			if((p = json_strval(v, '.', "data[%d].workflow_steps[%d].name", i, j)) != nil)
				fmtprint(&f, "	%s ", p);
			fmtprint(&f, "\n");

		}
		p = fmtstrflush(&f);
		newfile(n, name, nil, nil, nil, 0, 0, p);
		free(p);
	}
	json_free(v);
	return 0;
}


